Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
InvertibleESIGNFunction Class Reference

ESIGN trapdoor function using the private key. More...

Inheritance diagram for InvertibleESIGNFunction:

## Public Member Functions
void | Initialize (const Integer &n, const Integer &e, const Integer &p, const Integer &q)
| Initialize a ESIGN private key with {n,e,p,q}. More...
void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits)
| Create a ESIGN private key. More...
void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
| Applies the inverse of the trapdoor function, using random data if required. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
Public Member Functions inherited from ESIGNFunction
void | Initialize (const Integer &n, const Integer &e)
| Initialize a ESIGN public key with {n,e}. More...
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Integer | ImageBound () const
| Returns the maximum size of a message after the trapdoor function is applied. More...
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a message after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...
Public Member Functions inherited from RandomizedTrapdoorFunctionInverse
virtual bool | IsRandomized () const
| Determines if the decryption algorithm is randomized. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void CRYPTOPP_API | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

ESIGN trapdoor function using the private key.

Since
  Crypto++ 5.0

Definition at line 62 of file esign.h.

## Member Function Documentation

## ◆ Initialize() [1/2]

void InvertibleESIGNFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | p,
|  | const Integer & | q
| ) |  |
| inline

Initialize a ESIGN private key with {n,e,p,q}.

Parameters

  n | modulus
  e | public exponent
  p | first prime factor
  q | second prime factor

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 74 of file esign.h.

## ◆ Initialize() [2/2]

void InvertibleESIGNFunction::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits
| ) |  |
| inline

Create a ESIGN private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulud, in bits

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 83 of file esign.h.

## ◆ Save()

void InvertibleESIGNFunction::Save | ( | BufferedTransformation & | bt | ) | const
| inline virtual

Saves a key to a BufferedTransformation.

Parameters

  bt | the destination BufferedTransformation

Exceptions

  NotImplemented |

Save() writes the material to a BufferedTransformation.

If the material is a key, then the key is written with ASN.1 DER encoding. The key includes an object identifier with an algorthm id, like a subjectPublicKeyInfo.

A "raw" key without the "key info" can be saved using a key's DEREncode() method.

If a derived class does not override Save(), then the base class throws NotImplemented().

Reimplemented from CryptoMaterial.

Definition at line 87 of file esign.h.

## ◆ Load()

void InvertibleESIGNFunction::Load | ( | BufferedTransformation & | bt | ) |
| inline virtual

Loads a key from a BufferedTransformation.

Parameters

  bt | the source BufferedTransformation

Exceptions

  KeyingErr |

Load() attempts to read material from a BufferedTransformation. If the material is a key that was generated outside the library, then the following usually applies:

- the key should be ASN.1 BER encoded
- the key should be a "key info"

"key info" means the key should have an object identifier with an algorthm id, like a subjectPublicKeyInfo.

To read a "raw" key without the "key info", then call the key's BERDecode() method.

Note
  Load() generally does not check that the key is valid. Call Validate(), if needed.

Reimplemented from CryptoMaterial.

Definition at line 91 of file esign.h.

## ◆ BERDecode()

void InvertibleESIGNFunction::BERDecode | ( | BufferedTransformation & | bt | ) |
| virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Reimplemented from ESIGNFunction.

Definition at line 133 of file esign.cpp.

## ◆ DEREncode()

void InvertibleESIGNFunction::DEREncode | ( | BufferedTransformation & | bt | ) | const
| virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Reimplemented from ESIGNFunction.

Definition at line 143 of file esign.cpp.

## ◆ CalculateRandomizedInverse()

Integer InvertibleESIGNFunction::CalculateRandomizedInverse | ( | RandomNumberGenerator & | rng,
|  | const Integer & | x
| ) |  | const
| virtual

Applies the inverse of the trapdoor function, using random data if required.

Parameters

  rng | a RandomNumberGenerator derived class
  x | the message on which the decryption function is applied

Returns
  the message x decrypted under the private key

CalculateRandomizedInverse is a generalization of decryption using the private key The RandomNumberGenerator may (or may not) be required. Derived classes must implement it.

Implements RandomizedTrapdoorFunctionInverse.

Definition at line 153 of file esign.cpp.

## ◆ Validate()

bool InvertibleESIGNFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Reimplemented from ESIGNFunction.

Definition at line 194 of file esign.cpp.

## ◆ GetVoidValue()

bool InvertibleESIGNFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Reimplemented from ESIGNFunction.

Definition at line 217 of file esign.cpp.

## ◆ AssignFrom()

void InvertibleESIGNFunction::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Reimplemented from ESIGNFunction.

Definition at line 225 of file esign.cpp.

## ◆ GenerateRandom()

void InvertibleESIGNFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |
| virtual

parameters: (ModulusSize)

Reimplemented from GeneratableCryptoMaterial.

Definition at line 88 of file esign.cpp.

The documentation for this class was generated from the following files:

- esign.h
- esign.cpp